addHook('PlayerSpawn', function(p)
	if (p.canPressC1 == nil) then
		p.canPressC1 = true
	end
end)

local function abilityCheck(p)
	if p.charability == CA_FLY then
		return 'tails'
	elseif p.charability == CA_THOK then
		return 'sonic'
	end
end

local function colorCheck(p)
	if p.charability == CA_FLY then
		return '32'
	elseif p.charability == CA_THOK then
		return '55'
	end
end

hud.add(function(v, p)
	if (p.mo.skin ~= 'poyo') then
		return
	end
	
	local spritecolor = v.getColormap(abilityCheck(p), colorCheck(p))
	local tailssprite = v.getSprite2Patch(abilityCheck(p), SPR2_XTRA, false, C, 2)
	
	v.drawString(16, 163, "Ability:", V_SNAPTOBOTTOM)
	v.drawScaled(83*FRACUNIT, 171*FRACUNIT, FRACUNIT/2, tailssprite, V_SNAPTOBOTTOM, spritecolor)
end)

addHook('PlayerThink', function(p)
	if (p.mo.skin ~= 'poyo') then
		return
	end

	if (p.cmd.buttons & BT_CUSTOM1) and (p.mo.state ~= S_PLAY_PAIN or p.mo.state ~= S_PLAY_DEAD) and (p.canPressC1 == true) then
		p.canPressC1 = false
		p.pflags = p.pflags & ~PF_THOKKED
		if p.charability == CA_FLY then
			p.charability = CA_THOK
			p.actionspd = 65 * FRACUNIT
			p.abilityName = 'Thok'
		else
			p.charability = CA_FLY
			p.actionspd = 100 * FRACUNIT
			p.abilityName = 'Flight'
		end
	end

	if not (p.cmd.buttons & BT_CUSTOM1) then
		p.canPressC1 = true
	end

	if (p.pflags & PF_SPINNING) and (p.pflags & PF_JUMPED) then
		p.pflags = p.pflags & ~PF_SPINNING
	end
end)

addHook('AbilitySpecial', function(p)
	if (p.mo.skin ~= 'poyo') then
		return
	end

	if (p.charability == CA_THOK) then
		p.mo.state = S_PLAY_ROLL
		p.pflags = p.pflags & ~PF_THOKKED
	end
end)